<template>
  <div class="product-list">
    <v-container fluid>
      <div class="d-flex align-start">
        <v-col
          cols="12"
          xs="12"
          sm="12"
          md="2"
          lg="2"
          xl="2"
          class="d-flex align-start justify-end"
        >
          <div class="d-flex align-start flex-column" style="width: 100%;">
            <v-card class="style-card mb-5 col-xs-12 col-sm-12 col-md-12 col-lg-12 col-xl-12">
              <v-autocomplete
                :items="autocompleteWord"
                color="white"
                item-text="name"
                v-model="elkProduct"
                v-on:keyup="elkSearch($event.target.value)"
                label="Produit"
              ></v-autocomplete>
            </v-card>

            <v-card class="title style-card mb-5 col-xs-12 col-sm-12 col-md-12 col-lg-12 col-xl-12">
              Catégorie
              <v-checkbox
                v-for="(category,index) in categories"
                class="style-checkbox mx-2"
                :label="category.title"
                :key="category.id"
                v-model="selected[index]"
                v-on:change="elkCategory(category.title, index)"
              ></v-checkbox>
            </v-card>
          </div>
        </v-col>

        <v-col
          cols="12"
          xs="12"
          sm="12"
          md="10"
          lg="10"
          xl="10"
          class="d-flex align-start justify-start"
        >
          <div class="row">
            <div
              class="col-xs-12 col-sm-12 col-md-4 col-lg-4 col-xl-4"
              :key="item.id"
              v-for="item in items"
            >
              <v-card class="mx-auto" max-width="400">
                <router-link :to="item.id">
                  <v-img
                    class="white--text align-end"
                    height="250px"
                    style="background-color: gray"
                    :src="item.images.length > 0 ? getImage(item) : ''"
                  ></v-img>
                </router-link>

                <v-card-title>{{item.name}}</v-card-title>

                <v-card-text class="text--primary" style="height: 100px;">
                  <div>{{item.description.length > 150 ? item.description.substring(0,150) + '...': item.description}}</div>
                </v-card-text>

                <v-divider class="mx-4"></v-divider>

                <v-card-title>
                  <div style="width:100%;" class="d-flex flex-column">
                    <div class="mr-2">{{item.price}} €</div>

                    <div
                      style="width:100%;"
                    >Caution: {{item.caution !== undefined ? item.caution : 0}}€</div>
                  </div>

                  <div v-if="item.notation" class="body-2">
                    <star-rating
                      :inline="true"
                      :star-size="20"
                      :read-only="true"
                      :show-rating="false"
                      :rating="item.notation"
                      :round-start-rating="false"
                    ></star-rating>
                  </div>
                  <div v-else class="body-2">
                    <span>Aucune note sur ce produit.</span>
                  </div>
                </v-card-title>

                <v-card-actions>
                  <div
                    class="d-flex align-center justify-space-between"
                    style="width:100%;"
                    v-if="userData"
                  >
                    <div>
                      <div v-if="checkAdded(item) == true">
                        <v-btn
                          color="red"
                          @click="removeCart(item)"
                          class="mb-2 mb-sm-0"
                          style="color: white;"
                        >
                          <v-icon style="text-decoration: none;">mdi-cart-remove</v-icon>Retirer
                        </v-btn>
                      </div>

                      <div v-else>
                        <v-btn
                          color="orange"
                          @click="addCart(item)"
                          class="mb-2 mb-sm-0"
                          style="color: white;"
                        >
                          <v-icon style="text-decoration: none;">mdi-cart-plus</v-icon>Panier
                        </v-btn>
                      </div>
                    </div>
                  </div>

                  <div class="d-flex align-center justify-space-between" style="width:100%;" v-else>
                    <div class="d-flex flex-column">
                      <v-btn
                        disabled
                        color="orange"
                        class="mb-2 mb-sm-0"
                        style="color: white; width: 35%;"
                      >
                        <v-icon style="text-decoration: none;">mdi-cart-plus</v-icon>Panier
                      </v-btn>
                      <i style="font-size: 0.85em;">Veuillez vous connectez pour ajouter ce produit.</i>
                    </div>
                  </div>
                </v-card-actions>
              </v-card>
            </div>
          </div>
        </v-col>
      </div>
    </v-container>
  </div>
</template>

<script>
import { mapActions } from "vuex";
import { mapFields } from "vuex-map-fields";
import StarRating from "vue-star-rating";
import { ENTRYPOINT } from "../../config/entrypoint";

export default {
  name: "ProductList",
  servicePrefix: "Product",
  components: {
    StarRating
  },
  data() {
    return {
      elkProduct: "",
      wordFilterCategory: [],
      isIn: false,
      selected: [],
      urlGenerated: "",
      userData: JSON.parse(localStorage.getItem("user"))
    };
  },
  mounted: function() {
    this.$nextTick(function() {
      this.listProducts();
      this.listCategories();
      this.getCartProduct();
    })
  },
  computed: {
    ...mapFields("product", {
      items: "allProducts",
      categories: "categories",
      autocompleteWord: "autocompleteWord"
    }),
    ...mapFields("cart", {
      cart: "cart"
    })
  },
  methods: {
    getImage(product) {
      return ENTRYPOINT + "/media/" + product.images[0].filePath;
    },
    ...mapActions('product', ['listProducts', 'listCategories', 'autocompleteProduct', 'sendSearchProduct']),
    ...mapActions('cart', ['getCartProduct', 'addProductCart', 'removeProductCart']),
    addCart: function(product){
      this.addProductCart({productId: product.id, cartId: this.cart.id});
      setTimeout(() => this.sendSearchProduct(this.urlGenerated), 500);
    },
    removeCart: function(product) {
      this.removeProductCart({ productId: product.id, cartId: this.cart.id });
      setTimeout(() => this.sendSearchProduct(this.urlGenerated), 500);
    },
    elkSearch: function(word) {
      if (word.length > 2) {
        this.autocompleteProduct(word);
      } else {
        this.autocompleteWord = [];
      }
    },
    elkCategory: function(category, index) {
      var tab = [];
      this.categories.map(() => {
        tab[index] = "";
      });
      tab[index] = category;
      this.selected = tab;
      var url = "category=" + category;
      if (this.elkProduct.length > 0) {
        url = url + "&query=" + this.elkProduct;
      }
      this.urlGenerated = url;
      this.sendSearchProduct(url);
    },
    clearFilter: function() {
      this.listProducts();
      this.autocompleteWord = [];
      this.elkProduct = "";
    },
    checkAdded: function(product) {
      var isIn = false;
      if (this.cart.cartProducts != undefined) {
        if (this.cart.cartProducts.length > 0) {
          this.cart.cartProducts.map(function(value) {
            if (value.product.id == product.id && isIn == false) {
              isIn = true;
            }
          });
        }
      }
      return isIn;
    }
  },
  watch: {
    elkProduct: function(val) {
      var url = "query=" + val;
      var title = "";
      this.selected.map(value => {
        if (value) {
          title = value;
        }
      });
      if (title) {
        url = url + "&category=" + title;
      }
      this.urlGenerated = url;
      this.sendSearchProduct(url);
    }
  }
};
</script>
